<?php
require_once("Home.php"); // including home controller

/**
* class config
* @category controller
*/
class Admin_config_accounts extends Home
{

    public $user_id;
    /**
    * load constructor method
    * @access public
    * @return void
    */
    public function __construct()
    {
        parent::__construct();

        if ($this->session->userdata('logged_in')!= 1) {
            redirect('home/login_page', 'location');
        }

        $this->user_id=$this->session->userdata('user_id');
        //
        //
    }

    /**
    * load index method. redirect to config
    * @access public
    * @return void
    */
    public function index()
    {
        $this->configuration();
    }


    public function twitter_settings()
    {

        if ($this->session->userdata('user_type')!= 'Admin') {
            redirect('home/login_page', 'location');
        }

        $this->load->database();
        $this->load->library('grocery_CRUD');
        $crud = new grocery_CRUD();
        $crud->set_theme('flexigrid');
        $crud->set_table('twitter_config');
        $crud->where('deleted', '0');
        $crud->order_by('id');
        $crud->set_subject($this->lang->line("twitter settings"));
        $crud->required_fields('consumer_key', 'consumer_secret');
        $crud->columns('consumer_key', 'consumer_secret');
        $crud->fields('consumer_key', 'consumer_secret');

        $crud->unset_export();
        $crud->unset_print();
        // $crud->unset_read();

        $crud->display_as('consumer_key', $this->lang->line('Consumer Key'));
        $crud->display_as('consumer_secret', $this->lang->line('Consumer Secret'));

        $crud->callback_after_insert(array($this, 'insert_user_id_twitter'));

        $output = $crud->render();
        $data['output'] = $output;
        $data['crud'] = 1;
        $data['page_title'] = $this->lang->line("twitter settings");
        $this->_viewcontroller($data);
    }


    public function insert_user_id_twitter($post_array, $primary_key)
    {
        $id = $primary_key;
        $where = array('id'=>$id);
        $table = 'twitter_config';
        $data = array('user_id'=>$this->session->userdata("user_id"));
        $this->basic->update_data($table, $where, $data);
        return true;
    }


    public function linkedin_settings()
    {

        if ($this->session->userdata('user_type')!= 'Admin') {
            redirect('home/login_page', 'location');
        }

        $this->load->database();
        $this->load->library('grocery_CRUD');
        $crud = new grocery_CRUD();
        $crud->set_theme('flexigrid');
        $crud->set_table('linkedin_config');
        $crud->where('deleted', '0');
        $crud->order_by('id');
        $crud->set_subject($this->lang->line("linkedin settings"));
        $crud->required_fields('client_id', 'client_secret');
        $crud->columns('client_id', 'client_secret');
        $crud->fields('client_id', 'client_secret');

        $crud->unset_export();
        $crud->unset_print();
        // $crud->unset_read();

        $crud->display_as('client_id', $this->lang->line('Client ID'));
        $crud->display_as('client_secret', $this->lang->line('Client Secret'));

        $crud->callback_after_insert(array($this, 'insert_user_id_linkedin'));

        $output = $crud->render();
        $data['output'] = $output;
        $data['crud'] = 1;
        $data['page_title'] = $this->lang->line("linkedin settings");
        $this->_viewcontroller($data);
    }


    public function insert_user_id_linkedin($post_array, $primary_key)
    {
        $id = $primary_key;
        $where = array('id'=>$id);
        $table = 'linkedin_config';
        $data = array('user_id'=>$this->session->userdata("user_id"));
        $this->basic->update_data($table, $where, $data);
        return true;
    }


    public function tumblr_settings()
    {

        if ($this->session->userdata('user_type')!= 'Admin') {
            redirect('home/login_page', 'location');
        }

        $this->load->database();
        $this->load->library('grocery_CRUD');
        $crud = new grocery_CRUD();
        $crud->set_theme('flexigrid');
        $crud->set_table('tumblr_config');
        $crud->where('deleted', '0');
        $crud->order_by('id');
        $crud->set_subject($this->lang->line("tumblr settings"));
        $crud->required_fields('consumer_key', 'consumer_secret');
        $crud->columns('consumer_key', 'consumer_secret');
        $crud->fields('consumer_key', 'consumer_secret');

        $crud->unset_export();
        $crud->unset_print();
        // $crud->unset_read();

        $crud->display_as('consumer_key', $this->lang->line('Consumer Key'));
        $crud->display_as('consumer_secret', $this->lang->line('Consumer Secret'));

        $crud->callback_after_insert(array($this, 'insert_user_id_tumblr'));

        $output = $crud->render();
        $data['output'] = $output;
        $data['crud'] = 1;
        $data['page_title'] = $this->lang->line("tumblr settings");
        $this->_viewcontroller($data);
    }


    public function insert_user_id_tumblr($post_array, $primary_key)
    {
        $id = $primary_key;
        $where = array('id'=>$id);
        $table = 'tumblr_config';
        $data = array('user_id'=>$this->session->userdata("user_id"));
        $this->basic->update_data($table, $where, $data);
        return true;
    }


    public function pinterest_settings()
    {

        if ($this->session->userdata('user_type')!= 'Admin') {
            redirect('home/login_page', 'location');
        }

        $this->load->database();
        $this->load->library('grocery_CRUD');
        $crud = new grocery_CRUD();
        $crud->set_theme('flexigrid');
        $crud->set_table('pinterest_config');
        $crud->where('deleted', '0');
        $crud->order_by('id');
        $crud->set_subject($this->lang->line("pinterest settings"));
        $crud->required_fields('app_id', 'app_secret');
        $crud->columns('app_id', 'app_secret');
        $crud->fields('app_id', 'app_secret');

        $crud->unset_export();
        $crud->unset_print();
        // $crud->unset_read();

        $crud->display_as('app_id', $this->lang->line('App ID'));
        $crud->display_as('app_secret', $this->lang->line('App Secret'));

        $crud->callback_after_insert(array($this, 'insert_user_id_pinterest'));

        $output = $crud->render();
        $data['output'] = $output;
        $data['crud'] = 1;
        $data['page_title'] = $this->lang->line("pinterest settings");
        $this->_viewcontroller($data);
    }


    public function insert_user_id_pinterest($post_array, $primary_key)
    {
        $id = $primary_key;
        $where = array('id'=>$id);
        $table = 'pinterest_config';
        $data = array('user_id'=>$this->session->userdata("user_id"));
        $this->basic->update_data($table, $where, $data);
        return true;
    }


    public function img_api_settings()
    {

        if ($this->session->userdata('user_type')!= 'Admin') {
            redirect('home/login_page', 'location');
        }

        $this->load->database();
        $this->load->library('grocery_CRUD');
        $crud = new grocery_CRUD();
        $crud->set_theme('flexigrid');
        $crud->set_table('img_api_config');
        $crud->where('deleted', '0');
        $crud->order_by('id');
        $crud->set_subject($this->lang->line("pixabay api settings"));
        $crud->required_fields('api_key','status');
        $crud->columns('api_key','status');
        $crud->fields('api_key','status');
        $crud->callback_field('status', array($this, 'status_field_crud'));
        $crud->callback_column('status', array($this, 'status_display_crud'));

        $crud->unset_export();
        $crud->unset_print();
        $crud->unset_read();

        $crud->display_as('api_key', $this->lang->line('api key'));
        $crud->display_as('api_secret', $this->lang->line('api secret'));
        // $crud->display_as('api_name', $this->lang->line('api name'));
        $crud->display_as('status', $this->lang->line('status'));

        $output = $crud->render();
        $data['output'] = $output;
        $data['crud'] = 1;
        $data['page_title'] = $this->lang->line("pixabay api settings");
        $this->_viewcontroller($data);
    }

    public function status_field_crud($value, $row)
    {
        if ($value == '') {
            $value = 1;
        }
        return form_dropdown('status', array(0 => $this->lang->line('inactive'), 1 => $this->lang->line('active')), $value, 'class="form-control" id="field-status"');
    }

    public function status_display_crud($value, $row)
    {
        if ($value == 1) {
            return "<span class='label label-success'>".$this->lang->line('active')."</sapn>";
        } else {
            return "<span class='label label-warning'>".$this->lang->line('inactive')."</sapn>";
        }
    }




}
